/* replication of Gourinchas and Parker (Econometrica 2002) */
/* sam schulhofer-wohl, 9/13/2013 */
/* precalculations for analytically choosing best fit ctrend */
#include <mkl.h>
#include "gp_ssw_intel.h"

/* optcnum: Tx1, must exist on entry */
/* optcden: pointer to double */

void gp_ssw_optcsetup(const struct problem myproblem, double * optcnum, double * optcden)
{
  
  int i;
  double m[GP_SSW_T] __attribute__((aligned));
  for(i=0;i<GP_SSW_T;i++) m[i]=(double)i-0.5*((double)(GP_SSW_T-1));
  cblas_dgemv(CblasRowMajor,CblasNoTrans,GP_SSW_T,GP_SSW_T,1.0,myproblem.weightmat,GP_SSW_T,m,1,0,optcnum,1);
  *optcden=cblas_ddot(GP_SSW_T,optcnum,1,m,1);

}

