/* replication of Gourinchas and Parker (Econometrica 2002) */
/* sam schulhofer-wohl, 9/13/2013 */
/* analytically choose best fit ctrend */
#include <math.h>
#include <mkl.h>
#include "gp_ssw_intel.h"

double gp_ssw_optctrend(const struct problem myproblem, const struct problempart2 myproblempart2, const struct params1 params_stage1, const struct params2 params_stage2, const struct siminputs simshocks)
{
  
  int i;
  
  /* compute the consumption rule */
  double * rule;
  rule=(double *)malloc((GP_SSW_T+1)*GP_SSW_NGRID*sizeof(double));
  gp_ssw_rule(myproblem,myproblempart2,params_stage1,params_stage2,rule);

  /* simulate profiles using the rule */
  double * csim;
  csim=(double *)malloc(GP_SSW_T*sizeof(double));
  gp_ssw_sim(myproblempart2,simshocks,params_stage1,params_stage2,rule,csim,0,0);
  
  double moments[GP_SSW_T] __attribute__((aligned));
  #pragma ivdep
  for(i=0;i<GP_SSW_T;i++) moments[i]=log(csim[i])-myproblem.lcprofile[i];
  
  free(rule);
  free(csim);
  
  return cblas_ddot(GP_SSW_T,moments,1,myproblem.optcnum,1)/myproblem.optcden;

}

